
package de.ivu.elect.presentation.entschaedigung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.entschaedigung.form.AuszahlungViewFormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId("536")
@Named(AbstractAuszahlungCreateNoScopeView.COMPONENT_NAME)
public class AuszahlungCreateView extends AbstractAuszahlungCreateView {

  private static final long serialVersionUID = 1L;

  @Inject
  private AuszahlungViewFormBuilder auszahlungViewFormBuilder;

  public AuszahlungCreateView() {
    super();
  }

  @Override
  @PostConstruct
  public void init() {
    super.init();

    Auszahlung auszahlung = getEntity();

    if (isWahlSelected()) {
      Wahl wahl = getSelectedWahl();

      auszahlung.setWahl(wahl);
      auszahlung.setWahltermin(wahl.getWahltermin());
    }

    if (isWahlterminSelected()) {
      auszahlung.setWahltermin(getSelectedWahltermin());
    }
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Auszahlung auszahlung) {
    auszahlungViewFormBuilder.addProperties(formBuilder, auszahlung, false);
  }
}
